#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <utility>
#include <list>
#include <deque>
#include <cmath>

using namespace std;

typedef map<string, int> msi;
typedef map<string, pair<int, int>> mspi;

void fA() {
  int n, m;
  cin >> n >> m;
  if (n - 7 >= 1)
      cout << n - 7;
  else
      cout << m + 7;
}

int64_t count_bits(int64_t n)
{
    int64_t res {0};

    for (int64_t i {0}; i < 0x40; i++)
        res += (n >> i) & 1;

    return res;
}

uint64_t up_to_pow2(uint64_t n)
{
    uint64_t up {n};
    up |= (up >> 0x1);
    up |= (up >> 0x2);
    up |= (up >> 0x4);
    up |= (up >> 0x8);
    up |= (up >> 0x10);
    up |= (up >> 0x20);

    up = (up ^ (up >> 1)) << 1;

    return up;
}

uint64_t down_to_pow2(uint64_t n)
{
    uint64_t down {n};
    down |= (down << 0x1);
    down |= (down << 0x2);
    down |= (down << 0x4);
    down |= (down << 0x8);
    down |= (down << 0x10);
    down |= (down << 0x20);

    down = (down ^ (down << 1));

    return down;
}

void fE()
{
    int64_t n;
    cin >> n;

    while (n-- > 0)
    {
        int64_t Val;

        cin >> Val;

        Val = abs(Val);

        int64_t Res {0}, Cur {0};

        while (Cur != Val)
        {
            if (Cur < Val)
            {
                int64_t len_up {(int64_t)up_to_pow2(Val - Cur)};
                int64_t len_down {len_up >> 1};

                int64_t Cur1 {Cur + len_down};
                int64_t Cur2 {Cur + len_up};

                if (abs(Cur1 - Val) < abs(Cur2 - Val))
                    Cur = Cur1;
                else
                    Cur = Cur2;
            }
            else
            {
                int64_t len_up {(int64_t)up_to_pow2(Cur - Val)};
                int64_t len_down {len_up >> 1};

                int64_t Cur1 {Cur - len_down};
                int64_t Cur2 {Cur - len_up};

                if (abs(Cur1 - Val) < abs(Cur2 - Val))
                    Cur = Cur1;
                else
                    Cur = Cur2;
            }

            Res++;
        }

        cout << Res << "\n";
    }
}

void fC() {
    int n, sum = 0, i = 0;
    cin >> n;
    while (n > 0) {
        n -= ++i;
    }
    n += i;
    i -= !!n;
    for (; i > 0; i--) {
        if (n > 0) {
            sum += i * (i + 1);
            n--;
        }
        else
            sum += i * (i - 1);
    }
    cout << sum / 2;
}

void fH()
{
    int64_t n;
    cin >> n;
    int64_t m{ n + 1 };

    std::vector<int64_t> Res{};
    Res.resize(m);
    std::string Str{};
    Str.reserve(m + 2);

    cin >> Str;
    Str = 'B' + Str + 'B';

    int64_t min_used{ 0 }, max_used{ m + 1 }, flag{ 1 };

    for (int64_t i{ 0 }; i < m; i++)
    {
        if (Str[i] == 'A' || Str[i + 1] == 'A')
        {
            if (flag)
                Res[i] = ++min_used;
            else
                Res[i] = --max_used;

            flag ^= 1;
        }

        if (Str[i] == 'A' && Str[i + 1] != 'A')
            flag ^= 1;
    }

    for (int64_t i{ 0 }; i < m; i++)
        cout << ((Res[i] == 0) ? ++min_used : Res[i]) << " ";
}

/* 6 3 1 2 L 2 LL 1 0 LL 2 LLR 2 LR 2 R */

void fD() {
    int q, c, order = 0;
    vector<pair<int, int>> newColor(int64_t(1e7), {-1, -10});
    cin >> q >> c;
    string aim;
    //mspi newcolor;
    for (int i = 0; i < q; i++) {
        int t;
        cin >> t;
        if (t == 1) {
            int x, pos = 0;
            cin >> x;
            cin >> aim;
            for (int j = 0; j < aim.size(); j++)
                pos += pos + 1 + (aim[j] == 'R');
            newColor[pos] = make_pair(x, order++);
        } else {
            cin >> aim;
			int pos = 0;
            int curcolor = -1, curorder = -1;
            bool isColor = false;

            for (int j = 0; j < aim.size(); j++) {
                pos += pos + 1 + (aim[j] == 'R');
                auto it = newColor[pos];
                if (it.second > curorder) {
                    curcolor = it.first;
                    curorder = it.second;
                    isColor = true;
                }
                else if (isColor) {
                    if (aim[j] == 'L')
                        curcolor = (curcolor + 1) % c;
                    else
                        curcolor = (curcolor - 1 + c) % c;
                }
            }
            cout << curcolor << endl;
        }
    }
}

void fF()
{
    int64_t n, trg {};
    cin >> n;

    std::vector<int64_t> Arr {};
    Arr.resize(n);

    for (int64_t i {}; i < n; i++)
    {
        cin >> Arr[i];
        trg += Arr[i];
    }

    trg = (trg + 1) >> 1;

    int64_t beg {0}, end {0}, sum {0};

    std::vector<std::pair<int64_t, int64_t>> BestVals {};
    BestVals.reserve(n);
    BestVals.emplace_back(0, n - 1);
    int64_t BestSize {n};

    const auto &UpdBest {[&beg, &end, &BestVals, &BestSize](void) -> void
    {
        const int64_t CurSize {end - beg};

        if (CurSize < BestSize)
        {
            BestVals.clear();
            BestSize = CurSize;
        }

        if (CurSize <= BestSize)
            BestVals.emplace_back(beg, end - 1);
    }};

    const auto &UpdCur {[&end, &sum, &n, &Arr, &trg](void) -> bool
    {
        while (end < n && sum < trg)
            sum += Arr[end++];

        return (end >= n && sum < trg);
    }};

    UpdCur();
    UpdBest();

    beg = 1;

    for (; beg < n; beg++)
    {
        sum -= Arr[beg - 1];

        if (UpdCur())
            break;
        UpdBest();
    }

    int64_t
      sp_table_w {(int64_t)up_to_pow2(n)},
      sp_table_h {(int64_t)round(log2(sp_table_w))};

    std::vector<pair<int64_t, int64_t>> sp_table {(uint64_t)(sp_table_w * sp_table_h)};

    int64_t i {0};
    for (; i < n; i++)
        sp_table[i] = {Arr[i], Arr[i]};
    for (; i < sp_table_w; i++)
        sp_table[i] = {0, (int64_t)1e16};

    const auto &op {[](const pair<int64_t, int64_t> &A, const pair<int64_t, int64_t> &B) -> pair<int64_t, int64_t>
    {
        return {A.first + B.first, std::min(A.second, B.second)};
    }};

    for (int64_t i {1}, len {4}; i < sp_table_h; i++, (len <<= 1))
        for (int64_t j {0}; j < sp_table_w; j += len)
        {
            int64_t cen {j + (len >> 1)};
            sp_table[i * sp_table_w + cen] = sp_table[cen];
            sp_table[i * sp_table_w + cen - 1] = sp_table[cen - 1];

            for (int64_t k {cen + 1}; k < j + len; k++)
                sp_table[i * sp_table_w + k] = op(sp_table[i * sp_table_w + k - 1], sp_table[k]);
            for (int64_t k {cen - 2}; k >= j; k--)
                sp_table[i * sp_table_w + k] = op(sp_table[k], sp_table[i * sp_table_w + k + 1]);
        }

    const auto &GetVal {[&sp_table, &sp_table_w, &op](int64_t L, int64_t R) -> pair<int64_t, int64_t>
    {
        if (L == R)
            return sp_table[L];

        int64_t Layer {(int64_t)floor(log2(L ^ R))};

        return op(sp_table[sp_table_w * Layer + L], sp_table[sp_table_w * Layer + R]);
    }};

    for (auto &Elm : BestVals)
    {
        auto tmp {GetVal(Elm.first, Elm.second)};

        if (tmp.first - tmp.second >= trg)
        {
            cout << (BestSize - 1) << "\n";
            return;
        }
    }

    cout << BestSize << "\n";

    //cout << best << "\n";
}

void fK() {
    int n, k = int(1e7);
    cin >> n;
    vector<string> m(n);
    for (auto &s : m)
        cin >> s;
    sort(m.begin(), m.end());
    k = m[0].size();
    for (int i = 0; i < n; i += 2) {
        int j = 0;
        while (j < k && m[i][j] == m[i + 1][j])
            j++;
        k = min(j, k);
    }
    cout << k;
}

int main() {
    fD();
    return 0;
}
