#include<bits/stdc++.h>
using namespace std;

using ll = long long;
#define all(x) x.begin(), x.end()

const int K = 21;

template<typename T>
struct sparse_table {
    vector<array<T, K>> spt;

    void build(vector<T> a) {
        int n = a.size();
        spt.resize(n);
        for (int i = 0; i < n; ++i) spt[i][0] = a[i];
        for (int k = 0; (1 << k) < n; ++k) {
            for (int i = 0; i + (1 << k) < n; ++i) {
                spt[i][k + 1] = min(spt[i][k], spt[i + (1 << k)][k]);
            }
        }
    }

    T mn(int l, int r) {
        int k = __lg(r - l + 1);
        return min(spt[l][k], spt[r - (1 << k) + 1][k]);
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<ll> a(n);
    for (auto& i : a) cin >> i;
    ll sm = accumulate(all(a), 0ll);
    sparse_table<ll> spt;
    spt.build(a);
    int ans = n;
    vector<ll> pref(n + 1, 0);
    for(int i = 0; i < n; ++i) pref[i + 1] = pref[i] + a[i];
    for (int i = 0; i < n; ++i) {
        int l = -1, r = n - i - 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if ((pref[i + mid + 1] - pref[i]) * 2 >= sm) r = mid;
            else l = mid;
        }
        if ((pref[i + r + 1] - pref[i]) * 2 >= sm)
            ans = min(ans, r + 1);
        l = -1, r = n - i - 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if ((pref[i + mid + 1] - pref[i] - spt.mn(i, i + mid)) * 2 >= sm) r = mid;
            else l = mid;
        }
        if ((pref[i + r + 1] - pref[i] - spt.mn(i, i + r)) * 2 >= sm)
            ans = min(ans, r);
    }
    cout << ans;
}