#include<bits/stdc++.h>
using namespace std;

using ll = long long;

struct hashing {
    ll p = 31, mod = 1e9 + 9;
    vector<ll> pw, hh;

    hashing() {}
    hashing(string s) {
        int n = s.size();
        pw.assign(n + 1, 1);
        hh.assign(n + 1, 1);
        for (int i = 0; i < n; ++i) {
            pw[i + 1] = pw[i] * p % mod;
            hh[i + 1] = (hh[i] * p % mod + s[i] - 'a' + 1) % mod;
        }
    }

    ll get(int l, int r) {
        return (hh[r + 1] - (hh[l] * pw[r - l + 1] % mod) + mod) % mod;
    }
};

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<string> s(n);
    vector<hashing> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        h[i] = hashing(s[i]);
    }
    auto check = [&](int k) -> bool {
        map<ll, int> cnt;
        for (int i = 0; i < n; ++i) {
            if (s[i].size() < k) return 0;
            cnt[h[i].get(0, k - 1)]++;
        }
        for (auto [x, y] : cnt) {
            if (y & 1) return 0;
        }
        return 1;
    };
    int l = 0, r = 2e6 + 1;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (check(mid)) l = mid;
        else r = mid;
    }
    cout << l;
}