#include<bits/stdc++.h>
using namespace std;

using ll = long long;

using vec = pair<ll, ll>;

#define x first
#define y second
#define ff first
#define ss second
#define all(x) x.begin(), x.end()

#define int ll

vec operator-(vec a, vec b) {
    return {a.x - b.x, a.y - b.y};
}

ll cross_prod(vec a, vec b) {
    return a.x * b.y - a.y * b.x;
}

int cross_sign(vec a, vec b) {
    ll x = cross_prod(a, b);
    if (x < 0) return -1;
    if (x > 0) return 1;
    return 0;
}

ll dot_prod(vec a, vec b) {
    return a.x * b.x + a.y * b.y;
}

int dot_sign(vec a, vec b) {
    ll x = dot_prod(a, b);
    if (x < 0) return -1;
    if (x > 0) return 1;
    return 0;
}

bool check(vec a, vec b, vec c) {
    return cross_prod(b - a, c - a) == 0;
}

bool on_seg(vec a, vec b, vec c) {
    return check(a, b, c) && dot_sign(b - a, c - a) * dot_sign(a - b, c - b) >= 0;
}

bool cross(vec a, vec b, vec c, vec d) {
    if (cross_prod(b - a, d - c) == 0 && cross_prod(b - a, c - a) == 0) {
        return on_seg(a, b, c) || on_seg(a, b, d) || on_seg(c, d, a) || on_seg(c, d, b);
    }
    return cross_sign(c - d, a - d) * cross_sign(c - d, b - d) <= 0 && cross_sign(a - b, c - b) * cross_sign(a - b, d - b) <= 0;
}

ll len2(vec a) {
    return a.x * a.x + a.y * a.y;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<pair<vec, vec>> a(n);
    for (auto& i : a) cin >> i.ff.x >> i.ff.y >> i.ss.x >> i.ss.y;
    int ans = 0;
    for (int i = 0; i < n; ++i){
        for (int j = i + 1; j < n; ++j) {
            for (int k = j + 1; k < n; ++k) {
                bool ok = 0;
                vector<pair<vec, vec>> b = {a[i], a[j], a[k]};
                sort(all(b));
                do {
                    if (cross(b[0].ff, b[0].ss, b[1].ff, b[1].ss)) ok = 1;
                } while (next_permutation(all(b)));
                sort(all(b));
                do {
                    ll dist = min({
                                          len2(b[0].ff - b[1].ff),
                                          len2(b[0].ff - b[1].ss),
                                          len2(b[0].ss - b[1].ff),
                                          len2(b[0].ss - b[1].ss)
                    });
                    if (dist <= len2(b[2].ff - b[2].ss)) ok = 1;
                } while (next_permutation(all(b)));
                ans += ok;
            }
        }
    }
    cout << ans;
}