#define _USE_MATH_CONSTANTS
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <array>
#include <list>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <string>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <utility>
#include <tuple>

using namespace std;

using ll = long long;
using ull = unsigned long long;
using vi = std::vector<int>;
using vvi = std::vector<vi>;
using vb = std::vector<bool>;
using vvb = std::vector<vb>;
using pii = pair<int, int>;


#define all(c) (c).begin(), (c).end()
#define mk make_pair
#define pb push_back

ll euclid(ll a, ll b)
{
	if (a < b)
		swap(a, b);
	if (a % b == 0)
		return b;
	return euclid(a % b, b);
}

template<class _ty>
auto qpow(_ty a, ull pw)
{
	_ty res = 1;
	for (ull _pw = (1ull << 63); _pw > 0; _pw >>= 1)
	{
		res *= res;
		if (_pw & pw)
		{
			res *= a;
		}
	}
	return res;
}

constexpr int maxn = int(2e5);


namespace sgtree
{
	ll tree[maxn * 2];

	constexpr ll NEUTRAL = INT_MAX;

	int nn;

	auto combine = [](ll a, ll b) { return min(a, b); };

	void init(const vector<ll>& arr)
	{
		nn = arr.size();
		for (int i = nn; i < nn * 2; ++i)
		{
			tree[i] = arr[i - nn];
		}
	}

	void build(const vector<ll>& arr)
	{
		init(arr);
		for (int i = nn - 1; i >= 0; --i)
		{
			tree[i] = combine(tree[i << 1], tree[i << 1 | 1]);
		}
	}

	/*
	void set(int p)
	{
		for (p += nn; p > 1; p >>= 1)
		{
			tree[p << 1] = combine(tree[p], tree[p ^ 1]);
		}
	}
	*/

	ll get(int l, int r)
	{
		ll res = NEUTRAL;
		for (l += nn, r += nn; r > l; l >>= 1, r >>= 1)
		{
			if (l & 1) res = combine(res, tree[l++]);
			if (r & 1) res = combine(res, tree[--r]);
		}
		return res;
	}
}

//using namespace sgtree;

int n, m;

bool ok(int x, int y)
{
	return ((x >= 0) && (y >= 0) && (x < n) && (y < m));
}

vvi arr;

void solve()
{
	map <string, pair<ll, ll>> mq;
	ll q, c;
	cin >> q >> c;
	for (ll qqq = 0; qqq < q; qqq++) {
		ll typ;
		cin >> typ;
		if (typ == 1) {
			ll col;
			cin >> col;
			string s;
			cin >> s;
			mq[s] = { col, qqq };
		}
		else {
			ll t1 = 0, t2 = 0;
			string s;
			cin >> s;
			ll now = -1;
			ll gq = -1;
			while (!s.empty()) {
				auto it = mq.find(s);
				if (it != mq.end()) {
					if (now < it->second.second) {
						now = it->second.second;
						gq = (((it->second.first + t2 - t1) % c) + c) % c;
					}
				}
				if (s[s.size() - 1] == 'L') {
					t2++;
				}
				else {
					t1++;
				}
				s.pop_back();
			}
			cout << gq << endl;
		}
	}
}

/*
6 3
1 2
L
2
LL
1 0
LL
2
LLR
2
LR
2
R
*/

int main()
{
	cin.tie(nullptr)->sync_with_stdio(false);
	int tt = 1;
	//cin >> tt;
	while (tt--)
	{
		solve();
	}
	return 0;
}