#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

class node
{
public:
  node *L = nullptr, *R = nullptr;
  int CL = 0, CR = 0;

  node( node *LP = nullptr, node *RP = nullptr, int LC = 0, int RC = 0 ) : L(LP), R(RP), CL(LC), CR(RC)
  {
  }

  ~node( void )
  {
    if (L != nullptr)
      delete L;
    if (R != nullptr)
      delete R;
  }
};

class tree
{
public:
  node *Root = new node(nullptr, nullptr);

  tree( void )
  {
  }

  ~tree( void )
  {
    delete Root;
  }

  void ColorateNode( std::string &Str, int Color )
  {
    node **cur = &Root;
    int i;
    for (i = 0; i < Str.size() - 1; i++)
    {
      if (Str.data()[i] == 'L')
      {
        if ((*cur)->L == nullptr)
          (*cur)->L = new node();
        *cur = (*cur)->L;
      }
      else if (Str.data()[i] == 'R')
      {
        if ((*cur)->R == nullptr)
          (*cur)->R = new node();
        *cur = (*cur)->R;
      }
    }

    if (Str.data()[i] == 'L')
     (*cur)->CL = Color;
    else if (Str.data()[i] == 'R')
     (*cur)->CR = Color;
  }

  int GetColor( std::string &Str )
  {
    node **cur = &Root;
    int i;

    for (i = 0; i < Str.size() - 1; i++)
    {
      if (Str.data()[i] == 'L' && (*cur)->L != nullptr)
        *cur = (*cur)->L;
      else if (Str.data()[i] == 'R' && (*cur)->R != nullptr)
        *cur = (*cur)->R;
    }

    if (Str.data()[i] == 'L')
    {
      return (*cur)->CL;
    }
    if (Str.data()[i] == 'R')
    {
      return (*cur)->CR;
    }
  }
};

int main( void )
{
  int q, c, t;

  std::cin >> q >> c;

  tree Tree;
  for (int i = 0; i < q; i++)
  {
    std::cin >> t;
    
    std::string Zapros;
    if (t == 1)
    {
      int c;
      std::cin >> c;
      std::cin >> Zapros;//std::getline(//(std::cin, &Zapros);
      Tree.ColorateNode(Zapros, c);
    }
    else
    {
      std::cin >> Zapros;
      std::cout << Tree.GetColor(Zapros) << ' ';
    }
  }
  return 30;
}