#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll MOD = (ll)1e9 + 7, BASE = 239;

struct creation_of_hash {
	ll p{ 0 }, mod{ 0 };
	vector<ll> pw;
	vector<ll> pr;

	creation_of_hash() {
	}

	creation_of_hash(string& s, ll p, ll mod) {
		this->p = p;
		this->mod = mod;

		ll n = (ll)s.size();

		pw.resize(n + 1, 1);
		pr.resize(n + 1, 0);

		for (ll i = 1; i < n + 1; ++i) {
			pw[i] = pw[i - 1] * p % mod;
			pr[i] = (pr[i - 1] * p % mod + s[i - 1] - 'a' + 1) % mod;
		}
	}

	ll get_hash(ll x, ll l) {
		//x > 0
		return (pr[x + l - 1] - pr[x - 1] * pw[l] % mod + mod * mod) % mod;
	}
};

int main() {
	ll n;
	cin >> n;

	vector<creation_of_hash> all_hash;

	ll sz;

	for (ll i = 0; i < n; ++i) {
		string s;
		cin >> s;

		sz = (ll)s.size();

		all_hash.push_back(creation_of_hash{ s, BASE, MOD });
	}

	ll l = 0, r = sz + 1;

	while (r - l > 1) {
		ll m = (r + l) / 2;

		set<ll> s;

		for (ll i = 0; i < n; ++i) {
			ll h = all_hash[i].get_hash(1, m);

			if (s.find(h) != s.end()) {
				s.erase(h);
			}
			else {
				s.insert(h);
			}
		}

		if (s.empty()) {
			l = m;
		}
		else {
			r = m;
		}
	}

	cout << l << "\n";
}












//#include <bits/stdc++.h>
//#define int long long
//using namespace std;
//int lower_bound(vector<int>&step , int n){
//    int l = 0;
//    int r = step.size();
//    int m = (r + l) / 2;
//    while(l + 1 < r){
//        if(step[m] <= n){
//            l = m;
//        }
//        else{
//            r = m;
//        }
//        m = (l + r) / 2;
//    }
//    return step[l];
//}
//int upper_bound(vector<int>&step , int n){
//    int l = 0;
//    int r = step.size();
//    int m = (r + l) / 2;
//    while(l + 1 < r){
//        if(step[m] <= n){
//            l = m;
//        }
//        else{
//            r = m;
//        }
//        m = (l + r) / 2;
//    }
//    if(step[l] == n or l == step.size() - 1){
//        return step[l];
//    }
//    else{
//        return step[l + 1];
//    }
//}
//int32_t main() {
//    int t;
//    cin >> t;
//    vector<int>step;
//    for(int i = 0; i < 64 ; i ++){
//            step.push_back(pow(2 , i));
//    }
//
//    for(int i = 0; i < t ; i ++){
//        int n;
//        cin >> n;
//        n = abs(n);
//        int ter = 0;
//        while(n != 0){
//            n = (abs(n - lower_bound(step , n)) , abs(n - upper_bound(step , n)));
//            ter ++;
//            cout << n << " ";
//        }
//        cout << ter << "\n";
//    }
//}