#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>

using namespace std;

#define vec vector
#define forn(i, n) for(int i = 0; i < n; i++)


typedef long long ll;

struct pnt {
	long double x, y;
	pnt(long double xs, long double ys) {
		x = xs;
		y = ys;
	}
};

long double operator %(const pnt &a, const pnt &b) {
	return a.x * b.y - a.y * b.x;
}

long double operator *(const pnt& a, const pnt& b) {
	return a.x * b.x + a.y * b.y;
}

pnt operator -(const pnt& a, const pnt& b) {
	return pnt(a.x - b.x, a.y - b.y);
}

pnt operator +(const pnt& a, const pnt& b) {
	return pnt(a.x + b.x, a.y + b.y);
}

long double spnt(pnt a, pnt b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

long double s(pnt a, pnt b, pnt c) {
	if ((a - b) * (c - b) < 0) return spnt(a, b);
	if ((a - c) * (b - c) < 0) return spnt(a, c);
	return abs(((c - a) % (b - a))) / spnt(b, c);
}

long double s1(pair<pnt, pnt> a, pair<pnt, pnt> b) {
	long double ret = 1e18;

	ret = min(ret, s(a.first, b.first, b.second));
	ret = min(ret, s(a.second, b.first, b.second));
	ret = min(ret, s(b.first, a.first, a.second));
	ret = min(ret, s(b.second, a.first, a.second));
	cout << ret << "\n";
	return ret;
}

bool isgood(pair<pnt, pnt> a, pair<pnt, pnt> b, pair<pnt, pnt> c) {
	bool ret = 0;

	ret |= s1(a, b) <= spnt(c.first, c.second);
	ret |= s1(a, c) <= spnt(b.first, b.second);
	ret |= s1(c, b) <= spnt(a.first, a.second);

	return ret;
}

void solve() {
	ll n;
	cin >> n;
	string s;
	cin >> s;
	vector<ll> res;
	for (ll i = 0; i < n; i++) {
		if (s[i] == 'A') {
			res.push_back(i);
		}
	}
	vector<ll> a(n + 1);
	for (ll i = 0; i <= n; i++) {
		a[i] = i + 1;
	}
	for (ll i = 1; i < res.size(); i += 2) {
		swap(a[res[i]], a[res[i] + 1]);
	}
	for (auto r : a)
		cout << r << " ";
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}