#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>

using namespace std;

#define vec vector
#define forn(i, n) for(int i = 0; i < n; i++)


typedef long long ll;

struct pnt {
	__float128 x, y;
	pnt(__float128 xs, __float128 ys) {
		x = xs;
		y = ys;
	}
};

__float128 operator %(const pnt& a, const pnt& b) {
	return a.x * b.y - a.y * b.x;
}

__float128 operator *(const pnt& a, const pnt& b) {
	return a.x * b.x + a.y * b.y;
}

pnt operator -(const pnt& a, const pnt& b) {
	return pnt(a.x - b.x, a.y - b.y);
}

pnt operator +(const pnt& a, const pnt& b) {
	return pnt(a.x + b.x, a.y + b.y);
}

__float128 spnt(pnt a, pnt b) {
	return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
}

__float128 s(pnt a, pnt b, pnt c) {
	if ((a - b) * (c - b) < 0) return spnt(a, b);
	if ((a - c) * (b - c) < 0) return spnt(a, c);
	return (((c - a) % (b - a)) * ((c - a) % (b - a))) / spnt(b, c);
}

int sign(__float128 x) {
	if (x == 0) return 0;
	if (x > 0) return 1;
	return -1;
}



__float128 s1(pair<pnt, pnt> a, pair<pnt, pnt> b) {
	__float128 ret = 1e12;

	int sgn1 = sign((a.first - b.second) % (b.first - b.second));
	int sgn2 = sign((a.second - b.second) % (b.first - b.second));
	int sgn3 = sign((b.second - a.first) % (a.second - a.first));
	int sgn4 = sign((b.first - a.first) % (a.second - a.first));
	//cout << sgn1 << ' ' << sgn2 << ' ' << sgn3 << ' ' << sgn4 << "\n";
	if ((sgn1 == 0 || sgn2 == 0 || sgn1 != sgn2) && (sgn3 == 0 || sgn4 == 0 || sgn3 != sgn4)) return 0;

	ret = min(ret, s(a.first, b.first, b.second));
	ret = min(ret, s(a.second, b.first, b.second));
	ret = min(ret, s(b.first, a.first, a.second));
	ret = min(ret, s(b.second, a.first, a.second));
	//cout << ret << "\n";
	return ret;
}

bool isgood(pair<pnt, pnt> a, pair<pnt, pnt> b, pair<pnt, pnt> c) {
	bool ret = 0;

	ret |= s1(a, b) - spnt(c.first, c.second) <= 1e-12;
	ret |= s1(a, c) - spnt(b.first, b.second) <= 1e-12;
	ret |= s1(c, b) - spnt(a.first, a.second) <= 1e-12;

	return ret;
}

void solve() {
	int m;
	int x1, y1, x2, y2;
	cin >> m;

	vector <pair<pnt, pnt>> p;
	for (int i = 0; i < m; i++) {
		cin >> x1 >> y1 >> x2 >> y2;

		p.push_back({ pnt(x1, y1), pnt(x2, y2) });
	}

	//cout << s1(p[0], p[1]);
	
	int ans = 0;
	for (int i = 0; i < m; i++) {
		for (int j = i + 1; j < m; j++) {
			for (int k = j + 1; k < m; k++) {


				if (isgood(p[i], p[j], p[k])) {
					//cout << i << ' ' << j << ' ' << k << "\n";
					ans++;
				}

			}
		}
	}
	
	cout << ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	//s1({ pnt(1, 0), pnt(1, 2) }, { pnt(0, 1), pnt(2, 1) });


	solve();
	return 0;
}