#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;
#define ll long long
const int inf = 1 << 30;

struct tree {
    vector<int> t;
    int n;

    void build(int v, int l, int r, vector<int> &a) {
        if (l + 1 == r)t[v] = a[l];
        else {
            int m = (l + r) / 2;
            build(2 * v + 1, l, m, a);
            build(2 * v + 2, m, r, a);
            t[v] = min(t[2 * v + 1], t[2 * v + 2]);
        }
    }

    tree(vector<int> &a) {
        n = a.size();
        t.resize(4 * n);
        build(0, 0, n, a);
    }

    int sum(int v, int l, int r, int ql, int qr) {
        if (ql <= l && r <= qr){
            return t[v];
        }
        else if (qr <= l || r <= ql)return inf;
        else {
            int m = (l + r) / 2;
            return min(sum(2 * v + 1, l, m, ql, qr), sum(2 * v + 2, m, r, ql, qr));
        }
    }

    int minn(int l, int r) {
        return sum(0, 0, n, l, r);
    }
};

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i: a)cin >> i;
    tree tri(a);
    int l = 0;
    int r = 1;
    int ans = n;
    ll sum1 = 1, sum2 = a[0];
    for (auto i: a) sum1 += i;
    sum1 /= 2;
    while (l < n && r <= n) {
        if (sum2 >= sum1) {
            int x = tri.minn(l,r);
            if (sum2 - x >= sum1) {
                ans = min(ans, r - l - 1);
            } else ans = min(ans, r - l);
            l++;
            sum2 -= a[l - 1];
        } else {
            r++;
            sum2 += a[r - 1];
        }
    }
    cout << ans;
}
