#include <bits/stdc++.h>

using namespace std;

#define type long double
#define l first
#define r second

type eps = 1e-6;

struct P
{
    P(type _x,type _y){x = _x;y = _y;};
    P(){x=  0;y = 0;};
    type x,y;
    P operator +(const P & oth){return P(x+oth.x,y+oth.y);};
    P operator -(const P & oth){return P(x-oth.x,y-oth.y);};
    P operator *(type k){return P(k*x,k*y);};
};

type crs(P a,P b){return a.x*b.y-a.y*b.x;};
type dot(P a,P b){return a.x*b.x + a.y*b.y;};

type dist2(P a,P b)
{
    return (a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y);
}
type dist(pair<P, P>a)
{
    return sqrtl(dist2(a.l,a.r));
}
type dist_(P a, P b)
{
    return sqrtl(dist2(a, b));
}
type angle(P a,P b)
{
    return atan2(crs(a,b),dot(a,b));
}

type distps(P a, pair<P, P>b){
    //cout << "|||" << dot(a-b.l, b.r-b.l) << " " << dot(a-b.r, b.l-b.r) << "|||";
    if(dot(a-b.l, b.r-b.l)>=-eps && dot(a-b.r, b.l-b.r) >= -eps){
        //cout << abs(crs(b.l-a, b.r-b.l))/dist(b);
        return abs(crs(b.l-a, b.r-b.l))/dist(b);
    }else{
        return min(dist_(a, b.l), dist_(a, b.r));
    }
}

type distss(pair<P, P>a, pair<P, P>b){

    type a1, b1, c1;
    type a2, b2, c2;
    a1 = a.l.y - a.r.y;
    b1 = a.r.x - a.l.x;
    c1 = a.r.x*a.l.y - a.r.y*a.l.x;

    a2 = b.l.y-b.r.y;
    b2 = b.r.x - b.l.x;
    c2 = b.r.x*b.l.y - b.r.y*b.l.x;

    //cout << a1 << " " << b1 << " " << c1 << "   " << a2 << " " << b2 << " " << c2 << " | " << abs(a2*b1-a1*b2) << "\n";

    if(abs(a2*b1-a1*b2) < eps){return min(min(distps(a.l, b), distps(a.r, b)), min(distps(b.l, a), distps(b.r, a)));}

    type x1 = (c1*b2 - c2*b1)/(-b1*a2+b2*a1);
    type y1 = (c1*a2 - c2*a1)/(b1*a2 - b2*a1);
    //cout << "|" << x1 << " " << y1 << "|\n";
    P p_; p_.x=x1; p_.y=y1;
    if(dot(a.l-p_, a.r-p_)<=eps && dot(b.l-p_, b.r-p_)<=eps){return 0.;}

    return min(min(distps(a.l, b), distps(a.r, b)), min(distps(b.l, a), distps(b.r, a)));
}

int main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);
    int n; cin >> n;
    vector<pair<P, P> >a;
    for(int i = 0; i < n; i++){
        long double x1, x2, y1, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        P p1; p1.x=x1; p1.y=y1;
        P p2; p2.x=x2; p2.y=y2;
        a.push_back({p1, p2});
        //cout << dist(a[i]) << "\n";
    }
    int ans = 0;
    for(int i = 0; i < n; i++){
        for(int j = i+1; j < n; j++){
            for(int k = j+1; k < n; k++){
                if(distss(a[i], a[j]) <= dist(a[k])+eps || distss(a[i], a[k]) <= dist(a[j])+eps || distss(a[j], a[k]) <= dist(a[i])+eps){
                        ans++; //cout << i << " " << j << " " << k << "\n";
                        //cout << distss(a[i], a[j]) << " " << distss(a[i], a[k]) << " " << distss(a[j], a[k]) << "\n";
                        //cout << dist(a[k]) << " " << dist(a[j]) << " " << dist(a[i]) << "\n";
                }
            }
        }
    }
    cout << ans;
}
/*
4
1 1 2 3
1 3 2 1
3 1 4 3
2 6 3 6
*/
