#include<bits/stdc++.h>

#pragma GCC optimize("O3, fast-math")

#define nl "\n"
#define all(a) a.begin(),a.end()
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)

using namespace std;

int mod;

struct trie {
    struct node {
        int color = -1;
        node *left = nullptr;
        node *right = nullptr;

        node() = default;

        node(int color) : color(color) {}
    };

    node *root = new node();

    void add(string &path, int color) {
        node *cur = root;
        for (char &c: path) {
            if (c == 'L') {
                if (!cur->left) cur->left = new node();
                cur = cur->left;
            }
            if (c == 'R') {
                if (!cur->right) cur->right = new node();
                cur = cur->right;
            }
        }
        cur->color = color;
        cur->left = nullptr;
        cur->right = nullptr;
    }

    int get(string &path) {
        int ans = -1, last = path.size();
        node *cur = root;
        bool flag = false;
        for (int i = 0; i < path.size(); i++) {
            if (cur->color != -1) {
                ans = cur->color;
                last = i;
            }
            if (path[i] == 'L') {
                if (!cur->left) {
                    flag = true;
                    break;
                }
                cur = cur->left;
            }
            if (path[i] == 'R') {
                if (!cur->right) {
                    flag = true;
                    break;
                }
                cur = cur->right;
            }
        }
        if (cur->color != -1 && !flag) {
            ans = cur->color;
            last = path.size();
        }
        for (int i = last; i < path.size(); i++) {
            if (path[i] == 'L') ans = (ans + 1) % mod;
            else ans = (ans - 1 + mod) % mod;
        }
        return ans;
    }
};

void solve() {
    int q;
    cin >> q >> mod;
    trie T;
    while (q--) {
        int op;
        cin >> op;
        if (op == 1) {
            int x;
            string path;
            cin >> x >> path;
            T.add(path, x);
        } else {
            string path;
            cin >> path;
            cout << T.get(path) << nl;
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--) solve();

}
